/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
namespace Plugin {
// plugin comparison code
enum class IComparisonCode : uint32_t {
  lt = 0,
  le = 1,
  gt = 2,
  ge = 3,
  ltgt = 4,
  eq = 5,
  ne = 6,
  UNDEF = 7,
};

::std::optional<IComparisonCode> symbolizeIComparisonCode(uint32_t);
::llvm::StringRef stringifyIComparisonCode(IComparisonCode);
::std::optional<IComparisonCode> symbolizeIComparisonCode(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForIComparisonCode() {
  return 7;
}


inline ::llvm::StringRef stringifyEnum(IComparisonCode enumValue) {
  return stringifyIComparisonCode(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<IComparisonCode> symbolizeEnum<IComparisonCode>(::llvm::StringRef str) {
  return symbolizeIComparisonCode(str);
}

class IComparisonCodeAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = IComparisonCode;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static IComparisonCodeAttr get(::mlir::MLIRContext *context, IComparisonCode val);
  IComparisonCode getValue() const;
};
} // namespace Plugin
} // namespace mlir

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::mlir::Plugin::IComparisonCode, ::mlir::Plugin::IComparisonCode> {
  template <typename ParserT>
  static FailureOr<::mlir::Plugin::IComparisonCode> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for plugin comparison code");

    // Symbolize the keyword.
    if (::std::optional<::mlir::Plugin::IComparisonCode> attr = ::mlir::Plugin::symbolizeEnum<::mlir::Plugin::IComparisonCode>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid plugin comparison code specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::mlir::Plugin::IComparisonCode value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::mlir::Plugin::IComparisonCode> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::mlir::Plugin::IComparisonCode getEmptyKey() {
    return static_cast<::mlir::Plugin::IComparisonCode>(StorageInfo::getEmptyKey());
  }

  static inline ::mlir::Plugin::IComparisonCode getTombstoneKey() {
    return static_cast<::mlir::Plugin::IComparisonCode>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::mlir::Plugin::IComparisonCode &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::mlir::Plugin::IComparisonCode &lhs, const ::mlir::Plugin::IComparisonCode &rhs) {
    return lhs == rhs;
  }
};
}

namespace mlir {
namespace Plugin {
// plugin define code
enum class IDefineCode : uint32_t {
  MemRef = 0,
  IntCST = 1,
  SSA = 2,
  LIST = 3,
  StrCST = 4,
  ArrayRef = 5,
  Decl = 6,
  FieldDecl = 7,
  AddrExp = 8,
  Constructor = 9,
  Vec = 10,
  BLOCK = 11,
  COMPONENT = 12,
  TYPEDECL = 13,
  UNDEF = 14,
};

::std::optional<IDefineCode> symbolizeIDefineCode(uint32_t);
::llvm::StringRef stringifyIDefineCode(IDefineCode);
::std::optional<IDefineCode> symbolizeIDefineCode(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForIDefineCode() {
  return 14;
}


inline ::llvm::StringRef stringifyEnum(IDefineCode enumValue) {
  return stringifyIDefineCode(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<IDefineCode> symbolizeEnum<IDefineCode>(::llvm::StringRef str) {
  return symbolizeIDefineCode(str);
}

class IDefineCodeAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = IDefineCode;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static IDefineCodeAttr get(::mlir::MLIRContext *context, IDefineCode val);
  IDefineCode getValue() const;
};
} // namespace Plugin
} // namespace mlir

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::mlir::Plugin::IDefineCode, ::mlir::Plugin::IDefineCode> {
  template <typename ParserT>
  static FailureOr<::mlir::Plugin::IDefineCode> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for plugin define code");

    // Symbolize the keyword.
    if (::std::optional<::mlir::Plugin::IDefineCode> attr = ::mlir::Plugin::symbolizeEnum<::mlir::Plugin::IDefineCode>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid plugin define code specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::mlir::Plugin::IDefineCode value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::mlir::Plugin::IDefineCode> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::mlir::Plugin::IDefineCode getEmptyKey() {
    return static_cast<::mlir::Plugin::IDefineCode>(StorageInfo::getEmptyKey());
  }

  static inline ::mlir::Plugin::IDefineCode getTombstoneKey() {
    return static_cast<::mlir::Plugin::IDefineCode>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::mlir::Plugin::IDefineCode &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::mlir::Plugin::IDefineCode &lhs, const ::mlir::Plugin::IDefineCode &rhs) {
    return lhs == rhs;
  }
};
}

namespace mlir {
namespace Plugin {
// plugin expr code
enum class IExprCode : uint32_t {
  Plus = 0,
  Minus = 1,
  Mult = 2,
  PtrPlus = 3,
  Min = 4,
  Max = 5,
  BitIOR = 6,
  BitXOR = 7,
  BitAND = 8,
  Lshift = 9,
  Rshift = 10,
  Nop = 11,
  UNDEF = 12,
};

::std::optional<IExprCode> symbolizeIExprCode(uint32_t);
::llvm::StringRef stringifyIExprCode(IExprCode);
::std::optional<IExprCode> symbolizeIExprCode(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForIExprCode() {
  return 12;
}


inline ::llvm::StringRef stringifyEnum(IExprCode enumValue) {
  return stringifyIExprCode(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<IExprCode> symbolizeEnum<IExprCode>(::llvm::StringRef str) {
  return symbolizeIExprCode(str);
}

class IExprCodeAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = IExprCode;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static IExprCodeAttr get(::mlir::MLIRContext *context, IExprCode val);
  IExprCode getValue() const;
};
} // namespace Plugin
} // namespace mlir

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::mlir::Plugin::IExprCode, ::mlir::Plugin::IExprCode> {
  template <typename ParserT>
  static FailureOr<::mlir::Plugin::IExprCode> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for plugin expr code");

    // Symbolize the keyword.
    if (::std::optional<::mlir::Plugin::IExprCode> attr = ::mlir::Plugin::symbolizeEnum<::mlir::Plugin::IExprCode>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid plugin expr code specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::mlir::Plugin::IExprCode value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::mlir::Plugin::IExprCode> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::mlir::Plugin::IExprCode getEmptyKey() {
    return static_cast<::mlir::Plugin::IExprCode>(StorageInfo::getEmptyKey());
  }

  static inline ::mlir::Plugin::IExprCode getTombstoneKey() {
    return static_cast<::mlir::Plugin::IExprCode>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::mlir::Plugin::IExprCode &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::mlir::Plugin::IExprCode &lhs, const ::mlir::Plugin::IExprCode &rhs) {
    return lhs == rhs;
  }
};
}

